#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>

int main(int argc, char** argv) {
  pid_t pid;
  pid_t child_pid;
  int status;
  
  if ( (pid = fork()) > 0) {
    printf("[padre] Sono il processo padre - pid %d.\n", getpid());
    /* Aspetto che uno dei figli - NB IN QUESTO ESEMPIO C'E` UN SOLO PROCESSO FIGLIO */
    status = -1;
    
    /* child_pid non sarebbe necessario (il suo valore e` in pid) perche' c'e` un solo figlio. */
    child_pid = wait(&status);
    if(WIFEXITED(status)) {
      printf("[padre] Processo figlio %d terminato normalmente - tramite exit - con status %d\n", child_pid, WEXITSTATUS(status));
    } else {
      printf("[padre] Process figlio %d non terminato normalmente, cioe` non ha eseguito la exit.\n", child_pid);
    }
  } else if (pid == 0) {
    printf("[figlio] Sono il processo figlio - pid %d.\n", getpid());
    printf("[figlio] Eseguo la exec\n");
    execl("./figlio", "figlio", NULL);
    printf("---- Questa riga non dovrebbe essere mai stampata");
  } else {
    perror("[padre] Errore nella fork()");
  } 
  exit(EXIT_SUCCESS);
}
