#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

int main(int argc, char** argv) {
  pid_t pid;
  pid_t child_pid;
  int signo, status;
  
  if ( (pid = fork()) > 0) {
    printf("[padre] Sono il processo padre - pid %d.\n", getpid());    
    printf("[padre] Invio il segnale SIGINT al processo figlio.\n");
    kill(pid, SIGINT);
    status = -1;
    /* child_pid non e` necessario (il suo valore e` in pid) perche' c'e` un solo figlio. */
    child_pid = wait(&status);
    if(WIFEXITED(status)) {
      printf("[padre] Processo figlio %d terminato normalmente - tramite exit - con status %d\n", child_pid, WEXITSTATUS(status));
    } else if(WIFSIGNALED(status)) {
      signo = WTERMSIG(status);
      printf("[padre] Processo figlio %d terminato a causa del segnale %d - %s.\n", child_pid, signo, sys_siglist[signo]);
    } else {
      printf("[padre] Processo figlio non terminato normalmente, ne' a causa di un segnale.\n");
    } /* IF */
  } else if (pid == 0) {
    printf("[figlio] Sono il processo figlio - pid %d.\n", getpid());
    printf("[figlio] Eseguo la exec\n");
    execl("./figlio", "figlio", NULL);
    printf("---- Questa riga non dovrebbe essere mai stampata");
  } else {
    perror("[padre] Errore nella fork()");
  } 
  exit(EXIT_SUCCESS);
}
