#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>


int main(int argc, char** argv) {
  int i, n_children, n_terminated, status, signo;
  pid_t pid;
  
  /* PROVARE AD ESEGUIRE QUESTO PROGRAMMA CON UN INTERO N_CHILDREN MOLTO GRANDE */
  if(argc != 2) {
    fprintf(stderr, "Uso: %s n_figli\n", argv[0]);
    exit(EXIT_FAILURE);
  }
  
  n_children = atoi(argv[1]);
  if(n_children <= 0) {
    fprintf(stderr, "Uso: %s n_figli, con n_figli > 0\n", argv[0]);
    exit(EXIT_FAILURE);
  }
  
  for(i=0;i<n_children;i++) {
    if( (pid=fork()) > 0) {
      printf("[padre] Generato figlio i=%d con PID %d\n", (i+1), pid);
    } else if (pid == 0) {
      execl("./figlio", "figlio", NULL);
    } else {
      perror("Errore nella fork()");
    }
  } /* for */
  
  printf("[padre] Eseguo wait...\n");
  n_terminated = 0;
  while(n_terminated < n_children) {
    status = -1;
    pid = wait(&status);
    n_terminated++;
    if(pid < 0) {
      perror("Errore nella wait");
    } else if (WIFEXITED(status)) {
      printf("[padre] Processo figlio %d terminato normalmente - tramite exit - con status %d\n", pid, WEXITSTATUS(status));
    } else if(WIFSIGNALED(status)) {
      signo = WTERMSIG(status);
      printf("[padre] Processo figlio %d terminato a causa del segnale %d - %s.\n", pid, signo, sys_siglist[errno]);
    } else {
      printf("[padre] Processo figlio %d non terminato normalmente, ne' a causa di un segnale.\n", pid);
    } /* IF */
    printf("[padre] Figli ancora in esecuzione: %d\n", n_children - n_terminated); 
  } /* while */
  
  exit(EXIT_SUCCESS);
}
