#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>

static void set_sig_handlers(void);

int main(int argc, char** argv) {
  int pid;

  pid = getpid();
  printf("Processo avviato con PID %d\n", pid);
  set_sig_handlers();
  while(1) {
    printf("Mi sospendo...\n");
    pause();
  } /* while */
  exit(EXIT_SUCCESS);
} /* main */

void sigint_handler(int signo) {
  printf("Colto segnale SIGINT (signo=%d)\n", signo);
}

void sigquit_handler(int signo) {
  printf("Colto segnale SIGQUIT (signo=%d)\n", signo);
}


void set_sig_handlers(void) {
  /* In questo esercizio non e` necessario controllare se il segnale e` gia` gestito, ma in generale conviene
   * effettuare il test.
   */ 
  if (signal (SIGINT, SIG_IGN) != SIG_IGN) {
    if (signal(SIGINT, sigint_handler) == SIG_ERR) 
      fprintf (stderr, "Errore nella configurazione dell'handler SIGINT.\n");
  } 
  if (signal (SIGQUIT, SIG_IGN) != SIG_IGN) {
    if (signal(SIGQUIT, sigquit_handler) == SIG_ERR) 
      fprintf (stderr, "Errore nella configurazione dell'handler SIGQUIT.\n");
  }
} /* set_sig_handlers */
